package serialization;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.net.ServerSocket;
import java.net.Socket;

import serialization.PrimeFindClient.ClientMessage.ClientAskMessage;
import serialization.PrimeFindClient.ClientMessage.ClientPutMessage;

public class PrimeFindServer {

	PrimeFinder finder = new PrimeFinder();

	static public class GiveTaskResponse implements Serializable {

		private static final long serialVersionUID = 1L;
		
		PrimeFinder finder;

		public GiveTaskResponse(PrimeFinder finder) {
			this.finder = finder;
		}

		public PrimeFinder getFinder() {
			return finder;
		}
	}

	public static void main(String[] args) {
		PrimeFindServer server = new PrimeFindServer();
		server.run();
	}

	public void run() {
		while (true) {
			try (ServerSocket serverSocket = new ServerSocket(4444);
					Socket clientSocket = serverSocket.accept();
					ObjectOutputStream out = new ObjectOutputStream(clientSocket.getOutputStream());
					ObjectInputStream in = new ObjectInputStream(clientSocket.getInputStream());) {
				while (true) {
					Object request = in.readObject();
					if (request instanceof ClientAskMessage) {
						out.writeObject(new GiveTaskResponse(finder));
						out.flush();
					} else if (request instanceof ClientPutMessage) {
						finder = ((ClientPutMessage) request).getState();
						System.out.println(finder);
						break;
					}
				}

			} catch (IOException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		}
	}

}
