package serialization;
import java.io.Serializable;
import java.math.BigInteger;
import java.util.LinkedList;
import java.util.List;

public class PrimeFinder implements Serializable {

	private static final long serialVersionUID = 1L;

	List<BigInteger> primesFound = new LinkedList<>();

	BigInteger currentCandidate = BigInteger.valueOf(2);

	public void step() {
		if (checkPrime()) {
			primesFound.add(currentCandidate);
		}
		currentCandidate = currentCandidate.add(BigInteger.ONE);
	}

	private boolean checkPrime() {
		for (BigInteger i = BigInteger.valueOf(2); i
				.compareTo(currentCandidate.divide(BigInteger.valueOf(2))) <= 0; i = i.add(BigInteger.ONE)) {
			if (currentCandidate.remainder(i).equals(BigInteger.ZERO)) {
				return false;
			}
		}
		return true;
	}
	
	@Override
	public String toString() {
		return super.toString() + "primes so far: " + primesFound;
	}

}
